# Finout API V2

The Finout V2 API is the next generation of the Finout API, built for high-volume workloads and flexible, direct querying. V2 introduces richer filter and group-by capabilities, ability to query cost and usage data, higher rate limits, and virtual tag versioning (coming soon).&#x20;

{% hint style="info" %}
V2 is the recommended API for all new integrations. Use V1 only when you need APIs which are not yet available in V2.
{% endhint %}

***

### Authentication

All Finout V2 API requests require a Client ID and Secret Key. See [Generate an API Token](https://docs.finout.io/api/finout-api/generate-an-api-token) to get started.

***

### Available V2 APIs

* [Cost & Usage API V2](https://docs.finout.io/api/finout-api/cost-and-usage-api-v2-alpha)&#x20;
* [Query Language API V2](https://docs.finout.io/api/finout-api/finout-api-v2/query-language-api-v2)&#x20;
* [Virtual Tags API V2 (Beta)](/api/finout-api/finout-api-v2/virtual-tags-api-v2-beta.md)
* [Virtual Tag Versions API V2 (Beta)](/api/finout-api/finout-api-v2/virtual-tag-versions-api-v2-beta.md)
* [​Virtual Tag Metadata API V2 (Beta)](/api/finout-api/finout-api-v2/virtual-tag-metadata-api-v2-beta.md)

***

### FAQs

**What is the Finout V2 API?** \
The V2 API is the recommended API for all new integrations. It supports async cost and usage querying, direct filter construction without Views, higher rate limits and virtual tag versioning API (coming soon).

**When should I use V1 instead?** \
Use V1 for APIs that are not yet available in V2 such as the [Endpoint API](https://docs.finout.io/api/finout-api/endpoint-api-v1) and [CostGuard API](https://docs.finout.io/api/finout-api/costguard-api-v1).

**What are the V2 rate limits?** \
Rate limits are measured in requests per minute or day, applied per route, per account. See the rate limits in each endpoint documentation.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.finout.io/api/finout-api/finout-api-v2.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
